<template>
  <el-select
    v-model="value"
    multiple
    filterable
    remote
    clearable
    :multiple-limit="1"
    reserve-keyword
    :size="size || 'medium'"
    style="width: 100%"
    :placeholder="placeholder || ''"
    :disabled="disabled"
    :remote-method="remoteMethod"
    :loading="selectLoading"
    @change="selectChange"
  >
    <el-option
      v-for="(item, index) in options"
      :key="item.id + '' + index"
      :label="item.name + ''"
      :value="item.id + ''"
    />
  </el-select>
</template>

<script>
import asyncRequest from "@/apis/components/search-city";
import resToken from "@/mixins/resToken";
export default {
  name: "SearchCity",
  mixins: [resToken],
  props: ["size", "value", "placeholder", "isDetail", "disabled", "type", "names"],
  /**
   * 属性集合
   * @param {String}        size             : 组件大小            非必填
   * @param {Array}         value            : 选中值              必填
   * @param {String}        placeholder      : 提示信息            非必填
   * @param {Boolean}       isDetail         : 是否是详情逻辑       必填
   * @param {Boolean}       disabled         : 是否禁用            必填
   * @param {String}        names            : 选中值label         展示详情必填
   */
  /**
   * 事件集合
   * @searchChange             : 选中值变化调用   抛出选中数据
   */
  data() {
    return {
      options: [],
      selectLoading: false,
      searchName: "",
      formValue: {
        page: 1,
        size: 100,
        start: "",
        end: "",
        unit: "",
        creater: "",
      },
    };
  },
  watch: {
    names: function (val, old) {
      // console.log(val, old, this.isDetail, "1");
      this.searchName = val;
      if (this.isDetail && this.searchName) {
        this.remoteMethod(this.searchName);
      }
    },
  },
  mounted() {
    console.log("11111");
    this.options = [];
    this.selectLoading = false;
    this.remoteMethod("", true);
  },
  methods: {
    async selectChange(e) {
      if (e && e.length > 0) {
        const index = this.options.findIndex((v) => v.id + "" === e[0] + "");
        console.log(index);
        if (index !== -1) {
          const model = {
            id: this.options[index].id + "",
            code: this.options[index].id + "",
            label: this.options[index].unit + "",
          };
          this.$emit("searchChange", model);
        } else {
          this.$emit("searchChange", {});
        }
      } else {
        this.$emit("searchChange", {});
      }
    },
    async remoteMethod(query, type) {
      this.selectLoading = true;
      if (query !== "" || (type && query === "")) {
        this.options = [];
        this.formValue.name = query;
        const { code, data, message } = await asyncRequest.list(this.formValue);

        if (code === 1) {
          const { list } = data;
          this.options = list;
        } else {
          this.options = [];
        }
      } else {
        this.options = [];
      }
      this.selectLoading = false;
    },
  },
};
</script>

<style></style>
